/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-react-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-react-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, truncate } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Defaults } from "./Defaults";
import { TranslateTransform } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
var CrosshairLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.xAxisAnnotationFormatLabel = null;
        _this.yAxisAnnotationFormatLabel = null;
        _this.zn = null;
        _this.xa = null;
        _this.w9 = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.ji / 1000;
        _this.uf = a;
        _this.ue = b;
        _this.ug = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.get_d5 = function () {
        return true;
    };
    CrosshairLayer.prototype.get_d3 = function () {
        return true;
    };
    CrosshairLayer.prototype.cg = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.o0 = function (a) {
        _super.prototype.o0.call(this, a);
        this.w2 = a;
    };
    CrosshairLayer.prototype.w4 = function () {
        return this.xAxisAnnotationFormatLabel != null;
    };
    CrosshairLayer.prototype.w5 = function () {
        return this.yAxisAnnotationFormatLabel != null;
    };
    Object.defineProperty(CrosshairLayer.prototype, "zp", {
        get: function () {
            return new Thickness(1, this.xd, this.xf, this.xe, this.xc);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CrosshairLayer.prototype, "zq", {
        get: function () {
            return new Thickness(1, this.xj, this.xl, this.xk, this.xi);
        },
        enumerable: false,
        configurable: true
    });
    CrosshairLayer.prototype.vs = function (a, b) {
        if (this.w3 == null || this.w3 == a) {
            if (!this.at.c) {
                this.pp(b);
            }
        }
    };
    CrosshairLayer.prototype.vu = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.vu.call(this, a, b);
        var c = a;
        var d = this.w8;
        var e = this.w7;
        c.af.clear();
        c.ag.clear();
        c.ae.clear();
        c.ah.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.ul(this.w3)) {
            this.yk(this.w3, c, d, e);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.cy.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (this.ul(f)) {
                        this.yk(f, c, d, e);
                    }
                    if (f.isStacked) {
                        f.n5(function (g) {
                            if (_this.ul(g)) {
                                _this.yk(g, c, d, e);
                            }
                            if (g.dv) {
                                g.n3(function (h) {
                                    if (_this.ul(h)) {
                                        _this.yk(h, c, d, e);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (f.dv) {
                        f.n3(function (g) {
                            if (_this.ul(g)) {
                                _this.yk(g, c, d, e);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CrosshairLayer.prototype.ul = function (a) {
        if (!_super.prototype.ul.call(this, a)) {
            return false;
        }
        if (this.xt != null) {
            if (a.ep) {
                var b = a.lu();
                if (!Base.equalsStatic(this.xt, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.xt, a.name)) {
                    return false;
                }
            }
        }
        var c = this.vn(a);
        if (!c.c) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.oo = function () {
        _super.prototype.oo.call(this);
        if (!this.at.c && !this.dj()) {
            return;
        }
        if (this.dj()) {
            this.yl(this.ug, false);
        }
        else {
            this.yl(this.ue, false);
        }
    };
    CrosshairLayer.prototype.t5 = function () {
        return 1;
    };
    CrosshairLayer.prototype.us = function () {
        return 0.1;
    };
    CrosshairLayer.prototype.uv = function () {
        return -0.4;
    };
    CrosshairLayer.prototype.uu = function () {
        return 0.5;
    };
    CrosshairLayer.prototype.wr = function () {
        return this.t2 == 3 ? this.zo() : null;
    };
    CrosshairLayer.prototype.ws = function () {
        return this.t3 == 3 ? this.zo() : null;
    };
    CrosshairLayer.prototype.zo = function () {
        if (this.zn == null) {
            this.zn = new DoubleCollection();
            this.zn.add(DeviceUtils.g(5));
            this.zn.add(DeviceUtils.g(5));
        }
        return this.zn;
    };
    CrosshairLayer.prototype.yk = function (a, b, c, d) {
        var e = this.vn(a);
        if (!e.c) {
            return;
        }
        var f = e.d;
        f = a.th(f, c, d);
        var g = false;
        var h = this.ss;
        if (h == null) {
            h = this.sw;
        }
        if (h == null) {
            h = a.ss;
            g = true;
        }
        var i = false;
        var j = this.zh;
        if (j == null) {
            if (this.sw != null) {
                j = this.sw;
            }
            else {
                j = a.ss;
                i = true;
            }
        }
        var k = false;
        var l = this.zk;
        if (l == null) {
            if (this.sw != null) {
                l = this.sw;
            }
            else {
                l = a.ss;
                k = true;
            }
        }
        var m = h;
        var n = h;
        var o = j;
        var p = l;
        if (this.zf != null) {
            m = this.zf;
        }
        else if (g) {
            switch (this.t2) {
                case 0:
                case 1:
                    m = this.w2.ce(m, this.up);
                    break;
                case 2:
                    m = this.w2.cg(m, this.up);
                    break;
                case 4:
                    m = this.w2.cf(m, this.up);
                    break;
            }
        }
        if (this.zg != null) {
            n = this.zg;
        }
        else if (g) {
            switch (this.t3) {
                case 0:
                case 1:
                    n = this.w2.ce(n, this.ur);
                    break;
                case 2:
                    n = this.w2.cg(n, this.ur);
                    break;
                case 4:
                    n = this.w2.cf(n, this.ur);
                    break;
            }
        }
        if (i) {
            switch (this.t3) {
                case 1:
                    o = this.w2.ce(o, this.ur);
                    break;
                case 2:
                    o = this.w2.cg(o, this.ur);
                    break;
            }
        }
        if (k) {
            switch (this.t2) {
                case 1:
                    p = this.w2.ce(p, this.up);
                    break;
                case 2:
                    p = this.w2.cg(p, this.up);
                    break;
            }
        }
        b.ae.add(m);
        b.ah.add(n);
        b.af.add(f.y);
        b.ag.add(f.x);
        if (this.w6 && !isNaN_(f.y)) {
            AxisAnnotationFrameManager.c(b, f, a, this.cy, this.getEffectiveViewport(), h, o, this.xb, this.zj, this.zi, this.zp, this.xg, p, this.xh, this.zm, this.zl, this.zq, this.xm, this.zs == 0, this.zr == 0);
        }
    };
    CrosshairLayer.prototype.yl = function (a, b) {
        var c = false;
        if (this.w9 == null) {
            c = true;
            this.xa = new List$1(Axis.$, 0);
            this.w9 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.w9, this.xa, b, this.xn, this.xo, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    };
    CrosshairLayer.prototype.yj = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.ah._inner[c];
            f._fill = d.ah._inner[c];
        }
        else {
            f._stroke = d.ae._inner[c];
            f._fill = d.ae._inner[c];
        }
        f.ad = this.hk;
        f.ai = e ? this.wq : this.wp;
        f.am = this.ta;
        f.al = this.s9;
        f.ak = this.s9;
        f.aj = this.s8;
        f.ac = this.il;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.vx = function (a, b) {
        _super.prototype.vx.call(this, a, b);
        var c = this.w2.b8;
        var d = a;
        var e = d.af.count;
        var f = 0;
        var g = b.bx.left;
        var h = b.bx.right;
        var i = b.bx.top;
        var j = b.bx.bottom;
        var k = this.zs == 0;
        var l = this.zr == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.af._inner[m]);
            var o = Math.floor(d.ag._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.yj(c, f, m, d, true);
                p = q.c;
                f = q.d;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.an = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.yj(c, f, m, d, false);
                p = u.c;
                f = u.d;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.an = v;
            }
        }
        c.count = f;
        if (this.dj()) {
            this.yl(this.ug, true);
        }
        else {
            this.yl(this.ue, false);
        }
    };
    CrosshairLayer.prototype.fm = function () {
        return true;
    };
    CrosshairLayer.prototype.o8 = function (a, b, c, d) {
        _super.prototype.o8.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (d == null) {
                    if (this.w9 != null && this.w9.count > 0) {
                        var e = void 0;
                        if (this.dj()) {
                            e = this.ug;
                        }
                        else {
                            e = this.ue;
                        }
                        AxisAnnotationFrameManager.b(e);
                        AxisAnnotationFrameManager.d(this, e, true, this.w9, this.xa, true, this.xn, this.xo, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
                    }
                }
                break;
            case CrosshairLayer.$$p[1]:
                this.pp(true);
                break;
            case CrosshairLayer.$$p[8]:
                this.pp(true);
                break;
            case CrosshairLayer.$$p[4]:
            case CrosshairLayer.$$p[5]:
                this.pp(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[9]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[18]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[26]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[27]:
            case CrosshairLayer.$$p[28]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[7]:
            case CrosshairLayer.$$p[6]:
                this.pp(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:zf:ym', [Brush.$, null], 'HorizontalLineVisibility:zr:yn', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:w6:yo', [0, false], 'SkipUnknownValues:w7:yp', [0, true], 'TargetSeriesName:xt:yq', [2, null], 'TargetSeries:w3:yr', [Series.$, null], 'UseInterpolation:w8:ys', [0, true], 'VerticalLineStroke:zg:yt', [Brush.$, null], 'VerticalLineVisibility:zs:yu', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackgroundCornerRadius:xb:yv', [1, DeviceUtils.g(3)], 'XAxisAnnotationBackground:zh:yw', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:xn:yx', [1, -1], 'XAxisAnnotationOutline:zi:yy', [Brush.$, null], 'XAxisAnnotationPaddingBottom:xc:yz', [1, NaN], 'XAxisAnnotationPaddingLeft:xd:y0', [1, NaN], 'XAxisAnnotationPaddingRight:xe:y1', [1, NaN], 'XAxisAnnotationPaddingTop:xf:y2', [1, NaN], 'XAxisAnnotationStrokeThickness:xg:y3', [1, NaN], 'XAxisAnnotationTextColor:zj:y4', [Brush.$, null], 'YAxisAnnotationBackgroundCornerRadius:xh:y5', [1, DeviceUtils.g(3)], 'YAxisAnnotationBackground:zk:y6', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:xo:y7', [1, -1], 'YAxisAnnotationOutline:zl:y8', [Brush.$, null], 'YAxisAnnotationPaddingBottom:xi:y9', [1, NaN], 'YAxisAnnotationPaddingLeft:xj:za', [1, NaN], 'YAxisAnnotationPaddingRight:xk:zb', [1, NaN], 'YAxisAnnotationPaddingTop:xl:zc', [1, NaN], 'YAxisAnnotationStrokeThickness:xm:zd', [1, NaN], 'YAxisAnnotationTextColor:zm:ze', [Brush.$, null]]);
    return CrosshairLayer;
}(AnnotationLayer));
export { CrosshairLayer };
/**
 * @hidden
 */
var CrosshairLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b7 = null;
        _this.b8 = null;
        _this.b9 = null;
        _this.b7 = a;
        _this.b9 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.au = function () {
        var _this = this;
        _super.prototype.au.call(this);
        this.b8 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.ch);
            $ret.activate = runOn(_this, _this.ca);
            $ret.disactivate = runOn(_this, _this.cc);
            $ret.destroy = runOn(_this, _this.cb);
            return $ret;
        })());
        this.b7.iu = Defaults.j;
    };
    CrosshairLayerView.prototype.ch = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b9.add(a);
        return a;
    };
    CrosshairLayerView.prototype.ca = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.cc = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.cb = function (a) {
        this.b9.remove(a);
    };
    CrosshairLayerView.prototype.cd = function (a, b, c, d) {
        if (a.an == null || a.an.c.x != d || a.an.d.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.an = e;
        }
    };
    CrosshairLayerView.prototype.ce = function (a, b) {
        if (a == null) {
            return a;
        }
        return BrushUtil.m(a, b);
    };
    CrosshairLayerView.prototype.cg = function (a, b) {
        if (a == null) {
            return a;
        }
        return BrushUtil.o(a, b);
    };
    CrosshairLayerView.prototype.cf = function (a, b) {
        if (a == null) {
            return a;
        }
        var c = new Brush();
        c.color = Color.u(truncate((a.color.l * b)), a.color.o, a.color.n, a.color.m);
        return c;
    };
    CrosshairLayerView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b9.count; c++) {
                var d = this.b9._inner[c];
                if (d._visibility == 0) {
                    a.t(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        for (var b = 0; b < this.b9.count; b++) {
            this.e.a9.exportPathData(a, this.b9._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));
export { CrosshairLayerView };
